package com.gic.cloud.data.hook.service.impl;

import com.gic.cloud.data.hook.api.service.DecryptKeyService;
import com.gic.cloud.data.hook.service.dao.DhDecryptKeyMapper;
import com.gic.cloud.data.hook.api.dto.DhDecryptKey;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Calendar;
import java.util.Date;

@Service("decryptKeyService")
public class DecryptKeyServiceImpl implements DecryptKeyService {
    @Autowired
    private DhDecryptKeyMapper dhDecryptKeyMapper;

    @Override
    public void saveDecryKey(String enterpriseId, String publicKey, String privateKey) {
        DhDecryptKey key = new DhDecryptKey();
        key.setEnterpriseId(enterpriseId);
        key.setPublicKey(publicKey);
        key.setPrivateKey(privateKey);
        key.setCreateTime(new Date());
        key.setUpdateTime(new Date());
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.DAY_OF_MONTH, calendar.getActualMaximum(Calendar.DAY_OF_MONTH));
        Date time = calendar.getTime();
        key.setExpireTime(time);
        dhDecryptKeyMapper.insertSelective(key);
    }

    @Override
    public DhDecryptKey getKeyByEnterpriseId(String enterpriseId) {
        return dhDecryptKeyMapper.selectByEnterpriseId(enterpriseId);
    }
}
